Package com.scriptel.proscript

## Class Capabilities

- java.lang.Object
- - com.scriptel.proscript.Capabilities

-     public class Capabilities
      extends java.lang.Object

  This class represents the capabilities of a device. This information is only available from firmware versions >= 3.5.77.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static int` | `DISPLAY_TYPE_240X64_1X5_BLACKWHITE` | The device has a 240x64 pixel 1x5 inch black and white display.
    `static int` | `DISPLAY_TYPE_240X64_1X5_GRAYSCALE` | The device has a 240x64 pixel 1x5 inch grayscale display.
    `static int` | `DISPLAY_TYPE_NONE` | The device has no display.
    `static int` | `SCRIPTEL_CARDREADER_HID` | Deprecated. Please view the constant SCRIPTEL_MAG_CARDREADER_HID.
    `static int` | `SCRIPTEL_CARDREADER_INTERCHANGEABLE` | Deprecated. Please view the constant SCRIPTEL_MAG_CARDREADER_CHANGEABLE.
    `static int` | `SCRIPTEL_CARDREADER_KEYBOARD_BASIC` | Deprecated. Please view the constant SCRIPTEL_MAG_CARDREADER_KEYBOARD.
    `static int` | `SCRIPTEL_CARDREADER_KEYBOARD_PREAMBLE` | Deprecated. Please view the constant SCRIPTEL_MAG_CARDREADER_KEYBOARD.
    `static int` | `SCRIPTEL_CARDREADER_NONE` | Deprecated. New MagStrip constants are set up as a bit mask.
    `static int` | `SCRIPTEL_MAG_CARDREADER_CHANGEABLE` | The device has an equipped magnetic strip reader that can change between HID reports and keyboard events.
    `static int` | `SCRIPTEL_MAG_CARDREADER_HID` | The device has an equipped magnetic strip reader that will output swipes to vendor-specific HID.
    `static int` | `SCRIPTEL_MAG_CARDREADER_KEYBOARD` | The device has an equipped magnetic strip reader that will output swipes to raw keyboard events.
    `static int` | `SUPPORTED_BUFFERING` | Flag indicating that the device can buffer coordinate data and release it all at one time.
    `static int` | `SUPPORTED_COMPRESSION` | Flag indicating that the device supports compression of coordinate data.
    `static int` | `SUPPORTED_REPORTS_HID` | Flag indicating if this device supports vendor-specific HID based output reports for digitizer coordinates (ProScript).
    `static int` | `SUPPORTED_REPORTS_KEYBOARD` | Flag indicating if HID keyboard output is supported (EasyScript).
    `static int` | `SUPPORTED_REPORTS_MOUSE` | Flag indicating if this device supports HID mouse output reports for digitizer coordinates.
    `static int` | `SUPPORTED_REPORTS_PEN` | Flag indicating if pen output reports are supported.
    `static int` | `SUPPORTED_REPORTS_TOUCH` | Flag indicating if touch output reports are supported.
    `static int` | `SUPPORTED_STREAMING` | Flag indicating that the device supports streaming coordinates
    `static int` | `SUPPORTED_THROTTLING` | Flag indicating that the device supports throttling or slowing down of coordinate data

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `int` | `getBrightnessLevels()` | Gets the number of discreet brightness levels the device display supports.
    `int` | `getCalibrationXMax()` |
    `int` | `getCalibrationXMin()` |
    `int` | `getCalibrationYMax()` |
    `int` | `getCalibrationYMin()` |
    `int` | `getCardReader()` | Gets which card reader is equipped in the current device.
    `int` | `getColorDepth()` | Gets the color depth of the equipped display.
    `int` | `getContrastLevels()` | Gets the number of discreet contrast levels the device display supports.
    `int` | `getCoordinateModes()` | This method returns a bitmask containing which coordinate modes are supported
    `int` | `getCoordinateXMax()` | Gets the maximum logical coordinate in the horizontal direction.
    `int` | `getCoordinateXMin()` | Gets the minimum logical coordinate in the horizontal direction.
    `int` | `getCoordinateYMax()` | Gets the maximum logical coordinate in the vertical direction.
    `int` | `getCoordinateYMin()` | Gets the minimum logical coordinate in the vertical direction.
    `int` | `getDigitizerHeight()` | Gets the vertical size of the digitizing surface in millimeters.
    `int` | `getDigitizerWidth()` | Gets the horizontal size of the digitizing surface in millimeters.
    `int` | `getDisplayHeight()` | Gets the vertical resolution of the display in pixels.
    `int` | `getDisplayId()` | Gets the type of equipped display on the device.
    `int` | `getDisplayWidth()` | Gets the horizontal resolution of the display in pixels.
    `int` | `getReserved10()` | Reserved for future use.
    `int` | `getReserved11()` | Reserved for future use.
    `int` | `getReserved12()` | Reserved for future use.
    `int` | `getReserved13()` | Reserved for future use.
    `int` | `getReserved14()` | Reserved for future use.
    `int` | `getReserved4()` | Reserved for future use.
    `int` | `getReserved5()` | Reserved for future use.
    `int` | `getReserved6()` | Reserved for future use.
    `int` | `getReserved7()` | Reserved for future use.
    `int` | `getReserved9()` | Reserved for future use.
    `int` | `getSupportedReports()` | This method returns a bitmask containing which output reports this device supports.
    `boolean` | `getSupportsScreensResources()` | Returns whether this device is capable of using screen and resource calls.
    `boolean` | `isBufferingSupported()` | Does the device support buffering?
    `boolean` | `isCompressionSupported()` | Does the device support compression?
    `boolean` | `isKeyboardOutSupported()` | Does the device support keyboard output reports?
    `boolean` | `isStreamingSupported()` | Does the device support streaming?
    `boolean` | `isThrottlingSupported()` | Does the device support throttling?
    `java.lang.String` | `toString()` | Prints this object as a human readable string.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### SUPPORTED_REPORTS_HID

          public static final int SUPPORTED_REPORTS_HID

      Flag indicating if this device supports vendor-specific HID based output reports for digitizer coordinates (ProScript).
      See Also:
        Constant Field Values

    - #### SUPPORTED_REPORTS_MOUSE

          public static final int SUPPORTED_REPORTS_MOUSE

      Flag indicating if this device supports HID mouse output reports for digitizer coordinates.
      See Also:
        Constant Field Values

    - #### SUPPORTED_REPORTS_PEN

          public static final int SUPPORTED_REPORTS_PEN

      Flag indicating if pen output reports are supported.
      See Also:
        Constant Field Values

    - #### SUPPORTED_REPORTS_TOUCH

          public static final int SUPPORTED_REPORTS_TOUCH

      Flag indicating if touch output reports are supported.
      See Also:
        Constant Field Values

    - #### SUPPORTED_REPORTS_KEYBOARD

          public static final int SUPPORTED_REPORTS_KEYBOARD

      Flag indicating if HID keyboard output is supported (EasyScript).
      See Also:
        Constant Field Values

    - #### SUPPORTED_STREAMING

          public static final int SUPPORTED_STREAMING

      Flag indicating that the device supports streaming coordinates
      See Also:
        Constant Field Values

    - #### SUPPORTED_BUFFERING

          public static final int SUPPORTED_BUFFERING

      Flag indicating that the device can buffer coordinate data and release it all at one time.
      See Also:
        Constant Field Values

    - #### SUPPORTED_COMPRESSION

          public static final int SUPPORTED_COMPRESSION

      Flag indicating that the device supports compression of coordinate data.
      See Also:
        Constant Field Values

    - #### SUPPORTED_THROTTLING

          public static final int SUPPORTED_THROTTLING

      Flag indicating that the device supports throttling or slowing down of coordinate data
      See Also:
        Constant Field Values

    - #### DISPLAY_TYPE_NONE

          public static final int DISPLAY_TYPE_NONE

      The device has no display.
      See Also:
        Constant Field Values

    - #### DISPLAY_TYPE_240X64_1X5_BLACKWHITE

          public static final int DISPLAY_TYPE_240X64_1X5_BLACKWHITE

      The device has a 240x64 pixel 1x5 inch black and white display.
      See Also:
        Constant Field Values

    - #### DISPLAY_TYPE_240X64_1X5_GRAYSCALE

          public static final int DISPLAY_TYPE_240X64_1X5_GRAYSCALE

      The device has a 240x64 pixel 1x5 inch grayscale display.
      See Also:
        Constant Field Values

    - #### SCRIPTEL_CARDREADER_NONE

          @Deprecated
          public static final int SCRIPTEL_CARDREADER_NONE

      Deprecated.
      New MagStrip constants are set up as a bit mask.
      The device does not have an equipped card reader.
      See Also:
        Constant Field Values

    - #### SCRIPTEL_CARDREADER_HID

          @Deprecated
          public static final int SCRIPTEL_CARDREADER_HID

      Deprecated.
      Please view the constant SCRIPTEL_MAG_CARDREADER_HID.
      The device has an equipped magnetic strip reader that will output swipes to vendor-specific HID.
      See Also:
        Constant Field Values

    - #### SCRIPTEL_CARDREADER_KEYBOARD_BASIC

          @Deprecated
          public static final int SCRIPTEL_CARDREADER_KEYBOARD_BASIC

      Deprecated.
      Please view the constant SCRIPTEL_MAG_CARDREADER_KEYBOARD.
      The device has an equipped magnetic strip reader that will output swipes to raw keyboard events (no preamble).
      See Also:
        Constant Field Values

    - #### SCRIPTEL_CARDREADER_KEYBOARD_PREAMBLE

          @Deprecated
          public static final int SCRIPTEL_CARDREADER_KEYBOARD_PREAMBLE

      Deprecated.
      Please view the constant SCRIPTEL_MAG_CARDREADER_KEYBOARD.
      The device has an equipped magnetic strip reader that will output swipes to EasyScript keyboard events.
      See Also:
        Constant Field Values

    - #### SCRIPTEL_CARDREADER_INTERCHANGEABLE

          @Deprecated
          public static final int SCRIPTEL_CARDREADER_INTERCHANGEABLE

      Deprecated.
      Please view the constant SCRIPTEL_MAG_CARDREADER_CHANGEABLE.
      The device has an equipped magnetic strip reader that can switch between Proscript and EasyScript values.
      See Also:
        Constant Field Values

    - #### SCRIPTEL_MAG_CARDREADER_HID

          public static final int SCRIPTEL_MAG_CARDREADER_HID

      The device has an equipped magnetic strip reader that will output swipes to vendor-specific HID.
      See Also:
        Constant Field Values

    - #### SCRIPTEL_MAG_CARDREADER_KEYBOARD

          public static final int SCRIPTEL_MAG_CARDREADER_KEYBOARD

      The device has an equipped magnetic strip reader that will output swipes to raw keyboard events.
      See Also:
        Constant Field Values

    - #### SCRIPTEL_MAG_CARDREADER_CHANGEABLE

          public static final int SCRIPTEL_MAG_CARDREADER_CHANGEABLE

      The device has an equipped magnetic strip reader that can change between HID reports and keyboard events.
      See Also:
        Constant Field Values

  - ### Method Detail

    - #### toString

          public java.lang.String toString()

      Prints this object as a human readable string.
      Overrides:
        `toString` in class `java.lang.Object`
      Returns:
        Human readable string.

    - #### getSupportedReports

          public int getSupportedReports()

      This method returns a bitmask containing which output reports this device supports.
      Returns:
        Bitmask containing enabled output reports.
      See Also:
        `SUPPORTED_REPORTS_HID`, `SUPPORTED_REPORTS_MOUSE`, `SUPPORTED_REPORTS_PEN`, `SUPPORTED_REPORTS_TOUCH`, `SUPPORTED_REPORTS_KEYBOARD`

    - #### getCoordinateModes

          public int getCoordinateModes()

      This method returns a bitmask containing which coordinate modes are supported
      Returns:
        Bitmask containing the coordinate modes.
      See Also:
        `SUPPORTED_STREAMING`, `SUPPORTED_BUFFERING`, `SUPPORTED_COMPRESSION`, `SUPPORTED_THROTTLING`

    - #### getDisplayId

          public int getDisplayId()

      Gets the type of equipped display on the device.
      Returns:
        The identifier of the display used in this device.
      See Also:
        `DISPLAY_TYPE_NONE`, `DISPLAY_TYPE_240X64_1X5_BLACKWHITE`, `DISPLAY_TYPE_240X64_1X5_GRAYSCALE`

    - #### getBrightnessLevels

          public int getBrightnessLevels()

      Gets the number of discreet brightness levels the device display supports.
      Returns:
        Number of brightness levels the display supports.

    - #### getContrastLevels

          public int getContrastLevels()

      Gets the number of discreet contrast levels the device display supports.
      Returns:
        Number of contrast levels the display supports.

    - #### getColorDepth

          public int getColorDepth()

      Gets the color depth of the equipped display.
      Returns:
        Color depth of the display.

    - #### getDisplayWidth

          public int getDisplayWidth()

      Gets the horizontal resolution of the display in pixels.
      Returns:
        Horizontal resolution of the display in pixels.

    - #### getDisplayHeight

          public int getDisplayHeight()

      Gets the vertical resolution of the display in pixels.
      Returns:
        Vertical resolution of the display in pixels.

    - #### getDigitizerWidth

          public int getDigitizerWidth()

      Gets the horizontal size of the digitizing surface in millimeters.
      Returns:
        Horizontal size of the digitizing surface in millimeters.

    - #### getDigitizerHeight

          public int getDigitizerHeight()

      Gets the vertical size of the digitizing surface in millimeters.
      Returns:
        Vertical size of the digitizing surface in millimeters.

    - #### getCoordinateXMin

          public int getCoordinateXMin()

      Gets the minimum logical coordinate in the horizontal direction.
      Returns:
        Minimum logical coordinate in the horizontal direction.

    - #### getCoordinateXMax

          public int getCoordinateXMax()

      Gets the maximum logical coordinate in the horizontal direction.
      Returns:
        Maximum logical coordinate in the horizontal direction.

    - #### getCoordinateYMin

          public int getCoordinateYMin()

      Gets the minimum logical coordinate in the vertical direction.
      Returns:
        Minimum logical coordinate in the vertical direction.

    - #### getCoordinateYMax

          public int getCoordinateYMax()

      Gets the maximum logical coordinate in the vertical direction.
      Returns:
        Maximum logical coordinate in the vertical direction.

    - #### getCalibrationXMin

          public int getCalibrationXMin()

      Returns:
        the minimum x of the firmware's coordinate system

    - #### getCalibrationXMax

          public int getCalibrationXMax()

      Returns:
        the maximum x of the firmware's coordinate system

    - #### getCalibrationYMin

          public int getCalibrationYMin()

      Returns:
        the minimum y of the firmware's coordinate system

    - #### getCalibrationYMax

          public int getCalibrationYMax()

      Returns:
        the maximum y of the firmware's coordinate system

    - #### getReserved4

          public int getReserved4()

      Reserved for future use.
      Returns:
        Reserved for future use.

    - #### getReserved5

          public int getReserved5()

      Reserved for future use.
      Returns:
        Reserved for future use.

    - #### getCardReader

          public int getCardReader()

      Gets which card reader is equipped in the current device.
      Returns:
        The type of card reader equipped (if any).
      See Also:
        `SCRIPTEL_CARDREADER_HID`, `SCRIPTEL_CARDREADER_KEYBOARD_BASIC`, `SCRIPTEL_CARDREADER_KEYBOARD_PREAMBLE`, `SCRIPTEL_CARDREADER_NONE`

    - #### getReserved6

          public int getReserved6()

      Reserved for future use.
      Returns:
        Reserved for future use.

    - #### getReserved7

          public int getReserved7()

      Reserved for future use.
      Returns:
        Reserved for future use.

    - #### getSupportsScreensResources

          public boolean getSupportsScreensResources()

      Returns whether this device is capable of using screen and resource calls.
      Returns:
        True or false.

    - #### getReserved9

          public int getReserved9()

      Reserved for future use.
      Returns:
        Reserved for future use.

    - #### getReserved10

          public int getReserved10()

      Reserved for future use.
      Returns:
        Reserved for future use.

    - #### getReserved11

          public int getReserved11()

      Reserved for future use.
      Returns:
        Reserved for future use.

    - #### getReserved12

          public int getReserved12()

      Reserved for future use.
      Returns:
        Reserved for future use.

    - #### getReserved13

          public int getReserved13()

      Reserved for future use.
      Returns:
        Reserved for future use.

    - #### getReserved14

          public int getReserved14()

      Reserved for future use.
      Returns:
        Reserved for future use.

    - #### isBufferingSupported

          public boolean isBufferingSupported()

      Does the device support buffering?
      Returns:
        device capability

    - #### isStreamingSupported

          public boolean isStreamingSupported()

      Does the device support streaming?
      Returns:
        device capability

    - #### isThrottlingSupported

          public boolean isThrottlingSupported()

      Does the device support throttling?
      Returns:
        device capability

    - #### isCompressionSupported

          public boolean isCompressionSupported()

      Does the device support compression?
      Returns:
        device capability

    - #### isKeyboardOutSupported

          public boolean isKeyboardOutSupported()

      Does the device support keyboard output reports?
      Returns:
        device capability